diff --git a/django/contrib/admin/options.py b/django/contrib/admin/options.py
index ffc6e79..1a4ccc4 100644
--- a/django/contrib/admin/options.py
+++ b/django/contrib/admin/options.py
@@ -67,6 +67,7 @@ class BaseModelAdmin(object):
     prepopulated_fields = {}
     formfield_overrides = {}
     readonly_fields = ()
+    ordering = None
 
     def __init__(self):
         overrides = FORMFIELD_FOR_DBFIELD_DEFAULTS.copy()
@@ -189,6 +190,18 @@ class BaseModelAdmin(object):
     def get_readonly_fields(self, request, obj=None):
         return self.readonly_fields
 
+    def queryset(self, request):
+        """
+        Returns a QuerySet of all model instances that can be edited by the
+        admin site. This is used by changelist_view.
+        """
+        qs = self.model._default_manager.get_query_set()
+        # TODO: this should be handled by some parameter to the ChangeList.
+        ordering = self.ordering or () # otherwise we might try to *None, which is bad ;)
+        if ordering:
+            qs = qs.order_by(*ordering)
+        return qs
+
 class ModelAdmin(BaseModelAdmin):
     "Encapsulates all admin options and functionality for a given model."
 
@@ -202,7 +215,6 @@ class ModelAdmin(BaseModelAdmin):
     date_hierarchy = None
     save_as = False
     save_on_top = False
-    ordering = None
     inlines = []
 
     # Custom templates (designed to be over-ridden in subclasses)
@@ -325,18 +337,6 @@ class ModelAdmin(BaseModelAdmin):
             'delete': self.has_delete_permission(request),
         }
 
-    def queryset(self, request):
-        """
-        Returns a QuerySet of all model instances that can be edited by the
-        admin site. This is used by changelist_view.
-        """
-        qs = self.model._default_manager.get_query_set()
-        # TODO: this should be handled by some parameter to the ChangeList.
-        ordering = self.ordering or () # otherwise we might try to *None, which is bad ;)
-        if ordering:
-            qs = qs.order_by(*ordering)
-        return qs
-
     def get_fieldsets(self, request, obj=None):
         "Hook for specifying fieldsets for the add form."
         if self.declared_fieldsets:
@@ -1279,9 +1279,6 @@ class InlineModelAdmin(BaseModelAdmin):
         fields = form.base_fields.keys() + list(self.get_readonly_fields(request, obj))
         return [(None, {'fields': fields})]
 
-    def queryset(self, request):
-        return self.model._default_manager.all()
-
 class StackedInline(InlineModelAdmin):
     template = 'admin/edit_inline/stacked.html'
 
diff --git a/docs/ref/contrib/admin/index.txt b/docs/ref/contrib/admin/index.txt
index ac517e8..8e64ec7 100644
--- a/docs/ref/contrib/admin/index.txt
+++ b/docs/ref/contrib/admin/index.txt
@@ -1093,6 +1093,19 @@ all the same functionality as well as some of its own:
     doesn't directly correlate to the number of objects, but can if the value
     is small enough. See :ref:`model-formsets-max-num` for more information.
 
+.. attribute:: InlineModelAdmin.ordering
+
+    Set ``ordering`` to specify how inlines on the admin change form page should 
+    be ordered. This should be a list or tuple in the same format as a model's
+    ``ordering`` parameter.
+
+    If this isn't provided, the Django admin will use the model's default ordering.
+
+    .. admonition:: Note
+
+        Django will only honor the first element in the list/tuple; any others
+        will be ignored.
+
 .. attribute:: InlineModelAdmin.raw_id_fields
 
     By default, Django's admin uses a select-box interface (<select>) for
diff --git a/tests/regressiontests/admin_ordering/models.py b/tests/regressiontests/admin_ordering/models.py
index ad63685..fb76677 100644
--- a/tests/regressiontests/admin_ordering/models.py
+++ b/tests/regressiontests/admin_ordering/models.py
@@ -1,5 +1,6 @@
 # coding: utf-8
 from django.db import models
+from django.contrib import admin
 
 class Band(models.Model):
     name = models.CharField(max_length=100)
@@ -8,3 +9,18 @@ class Band(models.Model):
 
     class Meta:
         ordering = ('name',)
+
+class Song(models.Model):
+    band = models.ForeignKey(Band)
+    name = models.CharField(max_length=100)
+    duration = models.IntegerField()
+
+    class Meta:
+        ordering = ('name',)
+
+class SongInlineDefaultOrdering(admin.StackedInline):
+    model = Song
+
+class SongInlineNewOrdering(admin.StackedInline):
+    model = Song
+    ordering = ('duration', )
diff --git a/tests/regressiontests/admin_ordering/tests.py b/tests/regressiontests/admin_ordering/tests.py
index f63f202..1b91ac0 100644
--- a/tests/regressiontests/admin_ordering/tests.py
+++ b/tests/regressiontests/admin_ordering/tests.py
@@ -1,7 +1,7 @@
 from django.test import TestCase
 from django.contrib.admin.options import ModelAdmin
 
-from models import Band
+from models import Band, Song, SongInlineDefaultOrdering, SongInlineNewOrdering
 
 class TestAdminOrdering(TestCase):
     """
@@ -37,3 +37,37 @@ class TestAdminOrdering(TestCase):
         ma = BandAdmin(Band, None)
         names = [b.name for b in ma.queryset(None)]
         self.assertEqual([u'Radiohead', u'Van Halen', u'Aerosmith'], names)
+
+class TestInlineModelAdminOrdering(TestCase):
+    """
+    Let's make sure that InlineModelAdmin.queryset uses the ordering we define
+    in InlineModelAdmin.
+    """
+
+    def setUp(self):
+        b = Band(name='Aerosmith', bio='', rank=3)
+        b.save()
+        self.b = b
+        s1 = Song(band=b, name='Pink', duration=235)
+        s1.save()
+        s2 = Song(band=b, name='Dude (Looks Like a Lady)', duration=264)
+        s2.save()
+        s3 = Song(band=b, name='Jaded', duration=214)
+        s3.save()
+
+    def test_default_ordering(self):
+        """
+        The default ordering should be by name, as specified in the inner Meta
+        class.
+        """
+        inline = SongInlineDefaultOrdering(self.b, None)
+        names = [s.name for s in inline.queryset(None)]
+        self.assertEqual([u'Dude (Looks Like a Lady)', u'Jaded', u'Pink'], names)
+
+    def test_specified_ordering(self):
+        """
+        Let's check with ordering set to something different than the default.
+        """
+        inline = SongInlineNewOrdering(self.b, None)
+        names = [s.name for s in inline.queryset(None)]
+        self.assertEqual([u'Jaded', u'Pink', u'Dude (Looks Like a Lady)'], names)