Index: django/conf/locale/eu/LC_MESSAGES/django.po
===================================================================
--- django/conf/locale/eu/LC_MESSAGES/django.po	(revision 13428)
+++ django/conf/locale/eu/LC_MESSAGES/django.po	(working copy)
@@ -7,7 +7,7 @@
 "Project-Id-Version: Django\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2008-02-08 19:37+0100\n"
-"PO-Revision-Date: 2008-02-14 22:12+0100\n"
+"PO-Revision-Date: 2010-07-08 10:09+0200\n"
 "Last-Translator: Ibon\n"
 "Language-Team:  <es@li.org>\n"
 "MIME-Version: 1.0\n"
@@ -329,7 +329,7 @@
 #: contrib/admin/templates/admin/auth/user/change_password.html:14
 #: contrib/admin/templates/admin/auth/user/change_password.html:45
 msgid "Change password"
-msgstr "Hitz ezkutua aldatu"
+msgstr "Pasahitza aldatu"
 
 #: contrib/admin/templates/admin/base.html:30
 #: contrib/comments/templates/comments/form.html:6
@@ -452,18 +452,18 @@
 "Something's wrong with your database installation. Make sure the appropriate "
 "database tables have been created, and make sure the database is readable by "
 "the appropriate user."
-msgstr "Zerbait gaizki dago zure data-basearekin. Ziurtatu ezazu data-baseko taulak sortuak izan direla eta usuario egokiarengatik irakurriak izan daitekela"
+msgstr "Zerbait gaizki dago zure data-basearekin. Ziurtatu ezazu datu-baseko taulak sortu direla eta erabiltzaile egokiak duela irakurketa baimena"
 
 #: contrib/admin/templates/admin/login.html:17
 #: contrib/comments/templates/comments/form.html:6
 #: contrib/comments/templates/comments/form.html:8
 msgid "Username:"
-msgstr "Usuario Izena:"
+msgstr "Erabiltzaile izena:"
 
 #: contrib/admin/templates/admin/login.html:20
 #: contrib/comments/templates/comments/form.html:8
 msgid "Password:"
-msgstr "Hitz ezkutua:"
+msgstr "Pasahitza:"
 
 #: contrib/admin/templates/admin/login.html:25
 #: contrib/admin/views/decorators.py:25
@@ -476,7 +476,7 @@
 
 #: contrib/admin/templates/admin/object_history.html:18
 msgid "User"
-msgstr "Usuarioa"
+msgstr "Erabiltzailea"
 
 #: contrib/admin/templates/admin/object_history.html:19
 msgid "Action"
@@ -490,7 +490,7 @@
 msgid ""
 "This object doesn't have a change history. It probably wasn't added via this "
 "admin site."
-msgstr "Objetu honek ez du alketa zerrenda bat. Ziur asko, administrazio leku hau erabili gabe gehitua izan da."
+msgstr "Objetu honek ez dauka alketa zerrenda bat. Ziur asko, administrazio leku hau erabili gabe gehitua izan da."
 
 #: contrib/admin/templates/admin/pagination.html:10
 msgid "Show all"
@@ -532,31 +532,31 @@
 msgid ""
 "First, enter a username and password. Then, you'll be able to edit more user "
 "options."
-msgstr "Lehenengo usuario izena eta hitz ezkutua idatzi. Gero usuarioaren aukera gehiago aldatu ditzakezu"
+msgstr "Lehenengo erabiltzaile izena eta pasahitza idatzi. Gero erabiltzaile aukera gehiago aldatzeko aukera gehiago izango duzu"
 
 #: contrib/admin/templates/admin/auth/user/add_form.html:12
 msgid "Username"
-msgstr "Usuario izena"
+msgstr "Erabiltzaile izena"
 
 #: contrib/admin/templates/admin/auth/user/add_form.html:18
 #: contrib/admin/templates/admin/auth/user/change_password.html:33
 msgid "Password"
-msgstr "Hitz ezkutua"
+msgstr "Pasahitza"
 
 #: contrib/admin/templates/admin/auth/user/add_form.html:23
 #: contrib/admin/templates/admin/auth/user/change_password.html:38
 msgid "Password (again)"
-msgstr "Hitz ezkutua (berriro)"
+msgstr "Pasahitza (berriro)"
 
 #: contrib/admin/templates/admin/auth/user/add_form.html:24
 #: contrib/admin/templates/admin/auth/user/change_password.html:39
 msgid "Enter the same password as above, for verification."
-msgstr "Idatzi berriro hitz ezkutua."
+msgstr "Idatzi berriro pasahitza."
 
 #: contrib/admin/templates/admin/auth/user/change_password.html:27
 #, python-format
 msgid "Enter a new password for the user <strong>%(username)s</strong>."
-msgstr "Hitz ezkutu berria idatzi <strong>%(username)s</strong> usuarioarentzat."
+msgstr "Pasahitz berria idatzi <strong>%(username)s</strong> erabiltzailearentzat."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:3
 msgid "Bookmarklets"
@@ -578,19 +578,19 @@
 msgstr ""
 "\n"
 "<p class=\"help\">Markadoreak instalatzeko eraman linka zure erreminta panelera (toolbar).\n"
-"Orain markadorea lekuko edozein horritik aukeratu dezakezu. Hauetako \n"
+"Orain markadorea lekuko edozein orritik aukeratu dezakezu. Hauetako \n"
 "markadore batzu, zure ordenadorea 'barnekoa' bezala erregistratua egotea\n"
 "behar dute. Hitzegin web lekuaren administradorearekin azalpen gehiagorako.</p>\n"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:18
 msgid "Documentation for this page"
-msgstr "Web horri honentzat dokumentazioa"
+msgstr "Web orri honen dokumentazioa"
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:19
 msgid ""
 "Jumps you from any page to the documentation for the view that generates "
 "that page."
-msgstr "Edozein lekutik, horriaren bista sortzaileara (view) salto egiten du."
+msgstr "Edozein lekutik, orriaren bista sortzaileara (view) salto egiten du."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:21
 msgid "Show object ID"
@@ -600,7 +600,7 @@
 msgid ""
 "Shows the content-type and unique ID for pages that represent a single "
 "object."
-msgstr "Objetu bakarra erakusten duten horrietan, eduki mota (content-type) eta horriaren ID bakarra erakutsi, ."
+msgstr "Objetu bakarra erakusten duten orrietan, eduki mota (content-type) eta orriaren ID bakarra erakutsi, ."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:24
 msgid "Edit this object (current window)"
@@ -608,7 +608,7 @@
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:25
 msgid "Jumps to the admin page for pages that represent a single object."
-msgstr "Objetu bakarra erakusten horrietan, adminiztrazio gunera joan."
+msgstr "Objetu bakarra erakusten orrietan, adminiztrazio gunera joan."
 
 #: contrib/admin/templates/admin_doc/bookmarklets.html:27
 msgid "Edit this object (new window)"
@@ -631,78 +631,78 @@
 #: contrib/admin/templates/registration/password_change_form.html:5
 #: contrib/admin/templates/registration/password_change_form.html:9
 msgid "Password change"
-msgstr "Hitz ezkutua aldatu"
+msgstr "Pasahitza aldatu"
 
 #: contrib/admin/templates/registration/password_change_done.html:5
 #: contrib/admin/templates/registration/password_change_done.html:9
 msgid "Password change successful"
-msgstr "Hitz ezkutuaren aldaketa arrakastatsua"
+msgstr "Pasahitza ondo aldatu da"
 
 #: contrib/admin/templates/registration/password_change_done.html:11
 msgid "Your password was changed."
-msgstr "Hitz ezkutua aldatua izan da"
+msgstr "Pasahitza aldatu da"
 
 #: contrib/admin/templates/registration/password_change_form.html:11
 msgid ""
 "Please enter your old password, for security's sake, and then enter your new "
 "password twice so we can verify you typed it in correctly."
-msgstr "Idatzi hitz ezkutu zaharra segurtasun arrazoiengatik eta gero hitz ezkutu berria bi aldiz, akatsik egiten ez duzula ziurtatu dezagun."
+msgstr "Idatzi pasahitz zaharra segurtasun arrazoiengatik eta gero pasahitz berria bi aldiz, akatsik egiten ez duzula ziurtatu dezagun."
 
 #: contrib/admin/templates/registration/password_change_form.html:16
 msgid "Old password:"
-msgstr "Hitz ezkutu zaharra"
+msgstr "Pasahitz zaharra"
 
 #: contrib/admin/templates/registration/password_change_form.html:18
 msgid "New password:"
-msgstr "Hitz ezkutu berria:"
+msgstr "Pasahitz berria:"
 
 #: contrib/admin/templates/registration/password_change_form.html:20
 msgid "Confirm password:"
-msgstr "Hitz ezkutua baieztatu:"
+msgstr "Pasahitza baieztatu:"
 
 #: contrib/admin/templates/registration/password_change_form.html:22
 msgid "Change my password"
-msgstr "Nire hitz ezkutua aldatu"
+msgstr "Nire pasahitza aldatu"
 
 #: contrib/admin/templates/registration/password_reset_done.html:4
 #: contrib/admin/templates/registration/password_reset_form.html:4
 #: contrib/admin/templates/registration/password_reset_form.html:6
 #: contrib/admin/templates/registration/password_reset_form.html:10
 msgid "Password reset"
-msgstr "Hitz ezkutua ezabatu"
+msgstr "Pasahitza ezabatu"
 
 #: contrib/admin/templates/registration/password_reset_done.html:6
 #: contrib/admin/templates/registration/password_reset_done.html:10
 msgid "Password reset successful"
-msgstr "Hitz ezkutuaren ezabaketa zuzena"
+msgstr "Pasahitza ondo ezabatu da"
 
 #: contrib/admin/templates/registration/password_reset_done.html:12
 msgid ""
 "We've e-mailed a new password to the e-mail address you submitted. You "
 "should be receiving it shortly."
-msgstr "Hitz ezkutu berria e-mail bidez bidali dizugu. Epe laburrean jasokor duzu."
+msgstr "Pasahitz berria e-mail bidez bidali dizugu. Epe laburrean jasoko duzu."
 
 #: contrib/admin/templates/registration/password_reset_email.html:2
 msgid "You're receiving this e-mail because you requested a password reset"
-msgstr "Mezu elektroniko hau jaso dezu, hitz ezkutuaren ezabaketa eskatu duzulako"
+msgstr "Mezu elektroniko hau jaso dezu, pasahitzaren ezabaketa eskatu duzulako"
 
 #: contrib/admin/templates/registration/password_reset_email.html:3
 #, python-format
 msgid "for your user account at %(site_name)s"
-msgstr "%(site_name)s usuario kontuarentzat"
+msgstr "%(site_name)s erabiltzaile kontuarentzat"
 
 #: contrib/admin/templates/registration/password_reset_email.html:5
 #, python-format
 msgid "Your new password is: %(new_password)s"
-msgstr "Zure hitz ezkutu berria %(new_password)s da"
+msgstr "Zure pasahitz berria %(new_password)s da"
 
 #: contrib/admin/templates/registration/password_reset_email.html:7
 msgid "Feel free to change this password by going to this page:"
-msgstr "Hitz ezkutua aldatu nai baduzu, zoaz web horri honetara joan:"
+msgstr "Pasahitza aldatu dezakezu orri honetan:"
 
 #: contrib/admin/templates/registration/password_reset_email.html:11
 msgid "Your username, in case you've forgotten:"
-msgstr "Zure usuario izena (ahaztu badezu):"
+msgstr "Zure erabiltzaile izena (ahaztu badezu):"
 
 #: contrib/admin/templates/registration/password_reset_email.html:13
 msgid "Thanks for using our site!"
@@ -717,7 +717,7 @@
 msgid ""
 "Forgotten your password? Enter your e-mail address below, and we'll reset "
 "your password and e-mail the new one to you."
-msgstr "Hitz ezkutua ahaztu dezu ? Hidatzi zure e-mail helbidea, eta hitz ezkutu berri bat bidaliko dizugu."
+msgstr "Pasahitza ahaztu duzu? Idatzi zure e-mail helbidea, eta pasahitz berri bat bidaliko dizugu."
 
 #: contrib/admin/templates/registration/password_reset_form.html:16
 msgid "E-mail address:"
@@ -725,7 +725,7 @@
 
 #: contrib/admin/templates/registration/password_reset_form.html:16
 msgid "Reset my password"
-msgstr "Hitz ezkutua ezabatu"
+msgstr "Pasahitza ezabatu"
 
 #: contrib/admin/templates/widget/date_time.html:3
 msgid "Date:"
@@ -759,43 +759,43 @@
 
 #: contrib/admin/views/auth.py:31
 msgid "Add user"
-msgstr "Usuario gehitu"
+msgstr "Erabiltzailea gehitu"
 
 #: contrib/admin/views/auth.py:58
 msgid "Password changed successfully."
-msgstr "Hitz ezkutua aldaketa zuzena."
+msgstr "Ondo aldatu da pasahitza."
 
 #: contrib/admin/views/auth.py:65
 #, python-format
 msgid "Change password: %s"
-msgstr "Hitz ezkutua aldatu: %s"
+msgstr "Pasahitza aldatu: %s"
 
 #: contrib/admin/views/decorators.py:11 contrib/auth/forms.py:60
 msgid ""
 "Please enter a correct username and password. Note that both fields are case-"
 "sensitive."
-msgstr "Mesedez idatzi usuario izena eta hitz ezkutu egokiak. Maiskula eta minuskula ondo bereiztu."
+msgstr "Mesedez idatzi erabiltzaile izen eta pasahitz egokiak. Maiskula eta minuskula ondo bereiztu."
 
 #: contrib/admin/views/decorators.py:63
 msgid ""
 "Please log in again, because your session has expired. Don't worry: Your "
 "submission has been saved."
-msgstr "Mesedez berriro sar saitez, sesioa zahartu bai da. Bidalitakoa gorde egin da."
+msgstr "Sesioa iraungitu da. Mesedez sar zaitez berriro. Bidalitakoa gorde da."
 
 #: contrib/admin/views/decorators.py:70
 msgid ""
 "Looks like your browser isn't configured to accept cookies. Please enable "
 "cookies, reload this page, and try again."
-msgstr "Zure nabegatzaileak ez ditu cookie-ak onartzen. Aktiba ezazu hauen erabilera eta ekarri ezazu horria hau berriro."
+msgstr "Zure nabegatzaileak ez ditu cookie-ak onartzen. Aktiba ezazu hauen erabilera eta eskatu ezazu orria hau berriro."
 
 #: contrib/admin/views/decorators.py:84
 msgid "Usernames cannot contain the '@' character."
-msgstr "Usuario izenek ezin dezkete @ karakterea eduki."
+msgstr "Erabiltzaile izenek ezin dezkete @ karakterea eduki."
 
 #: contrib/admin/views/decorators.py:86
 #, python-format
 msgid "Your e-mail address is not your username. Try '%s' instead."
-msgstr "Zure e-mail helbidea ez da zure usuario izena. Ahalegindo '%s' rekin."
+msgstr "Zure e-mail helbidea ez da zure erabiltzaile izena. Ahalegindu '%s' rekin."
 
 #: contrib/admin/views/doc.py:48 contrib/admin/views/doc.py:50
 #: contrib/admin/views/doc.py:52
@@ -1031,17 +1031,17 @@
 
 #: contrib/auth/forms.py:17 contrib/auth/forms.py:138
 msgid "The two password fields didn't match."
-msgstr "Hitz ezkutuak ez dira berdinak."
+msgstr "Pasahitzak ez datoz bat."
 
 #: contrib/auth/forms.py:25
 msgid "A user with that username already exists."
-msgstr "Usuario izen hori erabiltzen ari da."
+msgstr "Erabiltzaile izen hori ez dago eskuragarri."
 
 #: contrib/auth/forms.py:53
 msgid ""
 "Your Web browser doesn't appear to have cookies enabled. Cookies are "
 "required for logging in."
-msgstr "Zure nabegatzaileak ez ditu cookiak onartzen. Cookia-k beharrezkoak dira sistemn sartzeko."
+msgstr "Zure nabegatzaileak ez ditu cookiak onartzen. Cookia-k beharrezkoak dira sisteman sartzeko."
 
 #: contrib/auth/forms.py:62
 msgid "This account is inactive."
@@ -1056,15 +1056,16 @@
 #: contrib/auth/forms.py:107
 #, python-format
 msgid "Password reset on %s"
-msgstr "Hitz ezkutu ezabatua %s n"
+msgstr "Pasahitza ezabatua %s n"
 
 #: contrib/auth/forms.py:117
 msgid "The two 'new password' fields didn't match."
-msgstr "Bi hitz ezkutu berriak ez dira berdinak."
+msgstr "Bi pasahitz berriak ez datoz bat."
 
+# c
 #: contrib/auth/forms.py:124
 msgid "Your old password was entered incorrectly. Please enter it again."
-msgstr "Zure hitz ezkutu zaharra ez zuzena. Idatzi ezazu berriro."
+msgstr "Zure pasahitz zaharra ez zuzena. Idatzi ezazu berriro."
 
 #: contrib/auth/models.py:73 contrib/auth/models.py:93
 msgid "name"
@@ -1092,7 +1093,7 @@
 
 #: contrib/auth/models.py:131
 msgid "username"
-msgstr "usuario izena"
+msgstr "erabiltzaile izena"
 
 #: contrib/auth/models.py:131
 msgid ""
@@ -1116,13 +1117,13 @@
 
 #: contrib/auth/models.py:135
 msgid "password"
-msgstr "hitz ezkutua"
+msgstr "pasahitza"
 
 #: contrib/auth/models.py:135
 msgid ""
 "Use '[algo]$[salt]$[hexdigest]' or use the <a href=\"password/\">change "
 "password form</a>."
-msgstr "Erabili '[algo]$[salt]$[hexdigest]' edo erabili <a href=\"password/\">hitz ezkuta aldatu </a>."
+msgstr "Erabili '[algo]$[salt]$[hexdigest]' edo erabili <a href=\"password/\">pasahitza aldatzeko formularioa </a>."
 
 #: contrib/auth/models.py:136
 msgid "staff status"
@@ -1130,7 +1131,7 @@
 
 #: contrib/auth/models.py:136
 msgid "Designates whether the user can log into this admin site."
-msgstr "Usuarioak administrazio gune honetan sartu dezkeen ala ez izendatzen du."
+msgstr "Erabiltzaileakk administrazio gune honetan sartzeko baimena duen edo ez adierazten du."
 
 #: contrib/auth/models.py:137
 msgid "active"
@@ -1140,17 +1141,17 @@
 msgid ""
 "Designates whether this user can log into the Django admin. Unselect this "
 "instead of deleting accounts."
-msgstr "Usuarioak Django adminiztrazio gunean sartu daitekeen ala ez. Desaktiba ezazu aukera hau,kontua ezabatu ordez."
+msgstr "Erabiltzaile Django adminiztrazio gunean sartu daitekeen edp ez adierazten du. Desaktiba ezazu aukera hau kontua ezabatu ordez."
 
 #: contrib/auth/models.py:138
 msgid "superuser status"
-msgstr "Usuario nagusia (superuser)"
+msgstr "Erabiltzaile nagusia (superuser)"
 
 #: contrib/auth/models.py:138
 msgid ""
 "Designates that this user has all permissions without explicitly assigning "
 "them."
-msgstr "Usuario honek baimen guztiak ditu, banan banan denak zehaztu gabe."
+msgstr "Erabiltzaile honek baimen guztiak ditu, banan-banan denak zehaztu gabe."
 
 #: contrib/auth/models.py:139
 msgid "last login"
@@ -1164,19 +1165,19 @@
 msgid ""
 "In addition to the permissions manually assigned, this user will also get "
 "all permissions granted to each group he/she is in."
-msgstr "Usuario honek, eskuz emandako baimen guztietaz aparte, berari egokitutako talde bakoitzari emandako baimenak ere izango ditu."
+msgstr "Erabiltzaile honek, eskuz emandako baimen guztiez gain, berari egokitutako talde bakoitzari emandako baimenak ere izango ditu."
 
 #: contrib/auth/models.py:143
 msgid "user permissions"
-msgstr "Usuarioaren baimenak"
+msgstr "Erabiltzailearen baimenak"
 
 #: contrib/auth/models.py:147
 msgid "user"
-msgstr "Usuarioa"
+msgstr "Erabiltzailea"
 
 #: contrib/auth/models.py:148
 msgid "users"
-msgstr "Usuarioak"
+msgstr "Erabiltzaileak"
 
 #: contrib/auth/models.py:154
 msgid "Personal info"
@@ -1350,11 +1351,11 @@
 
 #: contrib/comments/models.py:289
 msgid "user flag"
-msgstr "usuarioaren markaketa"
+msgstr "erabiltzailearen markaketa"
 
 #: contrib/comments/models.py:290
 msgid "user flags"
-msgstr "usuariaren markaketak"
+msgstr "erabiltzailearen markaketak"
 
 #: contrib/comments/models.py:294
 #, python-format
@@ -1380,7 +1381,7 @@
 
 #: contrib/comments/templates/comments/form.html:8
 msgid "Forgotten your password?"
-msgstr "Hitz ezkutua ahaztu duzu?"
+msgstr "Pasahitza ahaztu duzu?"
 
 #: contrib/comments/templates/comments/form.html:12
 msgid "Ratings"
@@ -1430,7 +1431,7 @@
 "comments:\n"
 "\n"
 "%(text)s"
-msgstr[0] "Komentario hau, %(count)s komentario baino gutxiago egindako usuario batek bidalia da:<br><br>%(text)s"
+msgstr[0] "Komentario hau, %(count)s komentario baino gutxiago egindako erabiltzaile batek bidalia da:<br><br>%(text)s"
 msgstr[1] ""
 
 #: contrib/comments/views/comments.py:117
@@ -1440,7 +1441,7 @@
 "\n"
 "%(text)s"
 msgstr ""
-"Komentario hau usuario 'arin' batek bidalia da:\n"
+"Komentario hau behin-behineko erabiltzaile batek bidali du:\n"
 "\n"
 "%(text)s"
 
@@ -1473,7 +1474,7 @@
 
 #: contrib/comments/views/karma.py:21
 msgid "Anonymous users cannot vote"
-msgstr "Usuario ezezagunak ezin dezakete botoa eman"
+msgstr "Erabiltzaile anonimoek ezin dezakete botorik eman"
 
 #: contrib/comments/views/karma.py:25
 msgid "Invalid comment ID"
@@ -1527,7 +1528,7 @@
 
 #: contrib/flatpages/models.py:14
 msgid "If this is checked, only logged-in users will be able to view the page."
-msgstr "Hau markatuta badago, erregistratutako usuarioak bakarrik ikusiko dute horria."
+msgstr "Hau markatuta badago, erregistratutako erabiltzaileek bakarrik ikusiko dute orria."
 
 #: contrib/flatpages/models.py:18
 msgid "flat page"